﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
    
    <asp:ScriptManager runat="server" ID="ScriptManager1" EnablePageMethods="true">
        <Scripts>
            <asp:ScriptReference Path="http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6" />
        </Scripts>
    </asp:ScriptManager>
    
    <div id="myMap" style="position:relative; width:600px; height:400px;"></div>
    
    <script type="text/javascript">
        var map = null;
        
        function LoadMap()
        {
            map = new VEMap("myMap");
            map.LoadMap(new VELatLong(47.6, -122.33), 10, VEMapStyle.Road);
            
            // Attach our OnMouseMove event handler
            map.AttachEvent("onmousemove", MapMouseMove);
            
            // Add a Shape to the Map.
            // And, Set the Title to our "special" format to include the Item ID
            var s = new VEShape(VEShapeType.Pushpin, map.GetCenter());
            s.Title = "LOAD:15";
            map.AddShape(s);
        }
        
        // Attach our LoadMap method to get executed
        // when the Application has finished loading.
        Sys.Application.add_load(LoadMap);
        
        
        // VE Map's OnMouseMove Event Handler
        function MapMouseMove(e)
        {
            if (e.elementID != null)
            {
                var shape = map.GetShapeByID(e.elementID);
                
                // Check if the Shapes been loaded already
                if (shape.GetTitle().indexOf("LOAD:") != -1)
                {
                    // Get our ID for the Shape from within the Shapes Title
                    var id = parseInt(shape.GetTitle().substring(5));
                    
                    // Set the Shape to display a loading message
                    shape.SetTitle("Loading...");
                    
                    // Fire off the loading of the InfoBox Data
                    PageMethods.GetInfoBoxData(id, /* <-- Pass the WebMethod its parameters */
                            InfoBoxDataLoaded, /* <-- The callback method that gets called when the Page Method call Succeeds */
                            InfoBoxDataLoadError, /* <-- The callback method that gets called if the Page Method Fails */
                            shape /* <-- Pass the Shape as our Context value to the callback method */
                            );
                }
            }
        }
        
        function InfoBoxDataLoaded(result, context, methodName)
        {
            var shape = context;
            
            // Set the Shapes new Title and Description
            shape.SetTitle(result.Title);
            shape.SetDescription(result.Description);
            // Re-Show the InfoBox so the new Title and Description are automatically displayed
            map.ShowInfoBox(shape);
        }
        
        function InfoBoxDataLoadError(error)
        {
            alert("Error Occurred Loading InfoBox Data\n" + error.get_message());
        }
    </script>
    
    </div>
    </form>
</body>
</html>
